Package com.ngrok.services

# Class CertificateAuthorities

java.lang.Object
com.ngrok.services.CertificateAuthorities

public class CertificateAuthorities extends Object
Certificate Authorities are x509 certificates that are used to sign other x509 certificates. Attach a Certificate Authority to the Mutual TLS module to verify that the TLS certificate presented by a client has been signed by this CA. Certificate Authorities are used only for mTLS validation only and thus a private key is not included in the resource. See also https://ngrok.com/docs/api#api-certificate-authorities.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `class`
  `CertificateAuthorities.CreateCallBuilder`
  A builder object encapsulating state for an unsent Create API call.
  `class`
  `CertificateAuthorities.DeleteCallBuilder`
  A builder object encapsulating state for an unsent Delete API call.
  `class`
  `CertificateAuthorities.GetCallBuilder`
  A builder object encapsulating state for an unsent Get API call.
  `class`
  `CertificateAuthorities.ListCallBuilder`
  A builder object encapsulating state for an unsent List API call.
  `class`
  `CertificateAuthorities.UpdateCallBuilder`
  A builder object encapsulating state for an unsent Update API call.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CertificateAuthorities(NgrokApiClient apiClient)`
  Creates a new sub-client for CertificateAuthorities.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `CertificateAuthorities.CreateCallBuilder`
  `create(String caPem)`
  Upload a new Certificate Authority See also https://ngrok.com/docs/api#api-certificate-authorities-create.
  `CertificateAuthorities.DeleteCallBuilder`
  `delete(String id)`
  Delete a Certificate Authority See also https://ngrok.com/docs/api#api-certificate-authorities-delete.
  `CertificateAuthorities.GetCallBuilder`
  `get(String id)`
  Get detailed information about a certficate authority See also https://ngrok.com/docs/api#api-certificate-authorities-get.
  `CertificateAuthorities.ListCallBuilder`
  `list()`
  List all Certificate Authority on this account See also https://ngrok.com/docs/api#api-certificate-authorities-list.
  `CertificateAuthorities.UpdateCallBuilder`
  `update(String id)`
  Update attributes of a Certificate Authority by ID See also https://ngrok.com/docs/api#api-certificate-authorities-update.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CertificateAuthorities

    public CertificateAuthorities(NgrokApiClient apiClient)
    Creates a new sub-client for CertificateAuthorities.
    Parameters:
      `apiClient` - an instance of `NgrokApiClient`

- ## Method Details

  - ### create

    public CertificateAuthorities.CreateCallBuilder create(String caPem)
    Upload a new Certificate Authority See also https://ngrok.com/docs/api#api-certificate-authorities-create.
    Parameters:
      `caPem` - raw PEM of the Certificate Authority
    Returns:
      a call builder for this API call

  - ### delete

    public CertificateAuthorities.DeleteCallBuilder delete(String id)
    Delete a Certificate Authority See also https://ngrok.com/docs/api#api-certificate-authorities-delete.
    Parameters:
      `id` - a resource identifier
    Returns:
      a call builder for this API call

  - ### get

    public CertificateAuthorities.GetCallBuilder get(String id)
    Get detailed information about a certficate authority See also https://ngrok.com/docs/api#api-certificate-authorities-get.
    Parameters:
      `id` - a resource identifier
    Returns:
      a call builder for this API call

  - ### list

    public CertificateAuthorities.ListCallBuilder list()
    List all Certificate Authority on this account See also https://ngrok.com/docs/api#api-certificate-authorities-list.
    Returns:
      a call builder for this API call

  - ### update

    public CertificateAuthorities.UpdateCallBuilder update(String id)
    Update attributes of a Certificate Authority by ID See also https://ngrok.com/docs/api#api-certificate-authorities-update.
    Parameters:
      `id` - the value of the `id` parameter as a `String`
    Returns:
      a call builder for this API call